var Ogs = function()
{
	var ogs = {};
	var debug = 1;
	
	ogs.initPage = function()
	{
		ogs.getHostInfo(false);
		Buttons.addClickHandler('btnReload', ogs.reloadConfiguration);
	}
	
	ogs.reloadConfiguration = function()
	{
		ogs.getHostInfo(true);
	}
	
	ogs.getHostInfo = function(reload)
	{
		var rows = Doc.element('all-rows');
		while (rows.lastChild)
		{
			rows.removeChild(rows.lastChild);
		}
		var template = Doc.element('row-template');
		var cols = template.getElementsByTagName('th');
		
		var wait = document.createElement('tr');
		wait.innerHTML = '<td colspan="'+cols.length+'"><div class="messagecontainer note">Loading cluster information. Please wait...</div></td>';
		rows.appendChild(wait);

		var url = '../../OpenGrid.servlet?ID='+App.getSessionId();
		url += '&cmd=GetHostInfo';
		if (reload) url += '&reload=1';
		var request = Ajax.getXmlHttpRequest();
		request.open("GET", url, true);
		Ajax.setReadyStateHandler(request, ogs.onHostInfoLoaded, ogs.onHostInfoLoaded);
		request.send(null);
	}
	
	ogs.onHostInfoLoaded = function(request)
	{
		if (debug) App.debug(Strings.encodeTags(request.responseText));
		var response;
		var error = false;
		try
		{
			response = JSON.parse(request.responseText);
			if (response.status != 'ok')
			{
				error = response.message || response.stacktrace || 'Unexpected error';
			}
		}
		catch (ex)
		{
			error = ex;
		}
		
		if (error)
		{
			alert(error);
			return;
		}

		var template = Doc.element('row-template');
		var cols = template.getElementsByTagName('th');
		
		var rows = Doc.element('all-rows');
		while (rows.lastChild)
		{
			rows.removeChild(rows.lastChild);
		}
		
		var clusters = response.clusters;
		for (var clusterNo = 0; clusterNo < clusters.length; clusterNo++)
		{
			var cluster = clusters[clusterNo];
			var info = cluster.hostInfo.info;
			
			var row = document.createElement('tr');
			row.className = clusterNo % 2 == 0 ? 'evenrow highlight' : 'oddrow highlight';
			
			for (var colNo = 0; colNo < cols.length; colNo++)
			{
				var cell = document.createElement('td');
				cell.className = 'cell';
				var colId = cols[colNo].id;
				if (colId == 'ogs.name')
				{
					cell.innerHTML = '<span class="link">'+Strings.encodeTags(cluster.name)+'<span>';
					Data.set(cell, 'cluster-id', cluster.id)
					Events.addEventHandler(cell, 'click', ogs.clusterOnClick);
				}
				else if (colId == 'ogs.ip')
				{
					cell.innerHTML = Strings.encodeTags(cluster.address + ':' + cluster.port);
				}
				else if (colId == 'ogs.timeDiff')
				{
					cell.innerHTML = cluster.timeAdjustment + ' seconds';
				}
				else if (colId == 'ogs.info')
				{
					var html;
					if (info.exitStatus == 0)
					{
						html = Strings.encodeTags(info.stdout);
					}
					else
					{
						html = '<div class="messagecontainer error">['+info.exitStatus+'] '+Strings.encodeTags(info.stderr)+'</div>';
					}
					cell.innerHTML = html;
				}
				else if (colId == 'ogs.status')
				{
					var img = info.exitStatus == 0 ? 'ok.png' : 'error.png';
					cell.className = 'ogs-status';
					cell.innerHTML = '<img src="../../images/'+img + '">';
				}
				row.appendChild(cell);
			}
			
			rows.appendChild(row);
		}
		
	}
	
	ogs.clusterOnClick = function(event)
	{
		var clusterId = Data.get(event.currentTarget, 'cluster-id');
		var url = 'view-cluster.jsp?ID='+App.getSessionId();
		url += '&clusterId='+encodeURIComponent(clusterId);
		location.href = url;
	}
	
	return ogs;
}();

Doc.onLoad(Ogs.initPage);
