<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

var debug = 1;
var currentStep = 1;
var alignedSequences;

function init()
{
	var frm = document.forms['reggie'];
	alignedSequences = getAlignedSequences();

	// Load existing aligned sequences
	if (alignedSequences != null && alignedSequences.length > 0)
	{
		gotoStep1();
	}
	else
	{
		var msg = 'No aligned sequences available for processing.';
		setFatalError(msg);
		return;
	}

}


function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{
		if (step1IsValid()) gotoStep2();
	}
	setCurrentStep(currentStep);
}

function step1IsValid()
{
	return true;
}



function getAlignedSequences()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading aligned sequences...');
		var url = '../MaskAlign.servlet?ID=<%=ID%>&cmd=GetUnconfirmedAlignedSequences';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.alignedSequences;
}


function formatDate(value)
{
	if (!value) return '';
	if (value.length == 8)
	{
		// YYYYMMDD
		value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2);
	}
	else if (value.length == 13)
	{
		// YYYYMMDD HHMM
		value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2) + ' ' + value.substr(9, 2) + ':' + value.substr(11, 2);
	}
	return value;
}


function gotoStep1()
{
	var frm = document.forms['reggie'];
	
	Main.show('gocancel');
	Main.show('goregister');
	Main.hide('gonext');
		
	var html = '<table id="alignedSequencesTable">';
	html += '<thead style="background-color: #E8E8E8; border-bottom: 1px solid #A0A0A0;">';
	// Header row
	html += '<tr>';
	html += '<th>Library</th>';
	html += '<th class="dottedleft">Plate</th>';
	html += '<th class="dottedleft" colspan="4">Reads</th>';
	html += '<th class="dottedleft">Job</th>';
	html += '<th class="dottedleft" colspan="4">Actions</th>';
	html += '<th class="dottedleft">Comment</th>';
	html += '</tr>';
	html += '<tr>';
	html += '<th></th>';
	html += '<th class="dottedleft"></th>';
	html += '<th class="dottedleft">PF_READS</th>';
	html += '<th>PT_READS</th>';
	html += '<th>PM_READS</th>';
	html += '<th>ALIGNED_PAIRS</th>';
	html += '<th class="dottedleft"></th>';
	html += '<th class="dottedleft">Files</th>';
	html += '<th>Flag RNA</th>';
	html += '<th>Re-align</th>';
	html += '<th>Cufflinks</th>';
	html += '<th class="dottedleft"></th>';
	html += '</tr>';
	html += '</thead>';
	html += '<tbody>';
	for (var alignedNo = 0; alignedNo < alignedSequences.length; alignedNo++)
	{
		var aligned = alignedSequences[alignedNo];

		var lib = aligned.lib;
		lib.stratagene = lib.name.indexOf(GENERIC_STRATAGENE_NAME) == 0;
		lib.external = lib.name.indexOf(EXTERNAL_RNA_NAME) == 0;
		var libPlate = lib.bioWell.bioPlate;
		
		var masked = aligned.masked;
		var merged = aligned.merged;
		var pfReads = merged.PF_READS == null ? '-' : formatNumber(merged.PF_READS/1000000, null, 2)
		var ptReads = merged.PT_READS == null ? '-' : formatNumber(merged.PT_READS/1000000, null, 2)
		var maskedReads = masked.PM_READS == null ? '-' : formatNumber(masked.PM_READS/1000000, null, 2)
		var alignedReads = aligned.ALIGNED_PAIRS == null ? '-' : formatNumber(aligned.ALIGNED_PAIRS/1000000, null, 2);
		var job = aligned.job;
		
		html += '<tr class="highlight ' + (alignedNo % 4 < 2 ? 'evenrow' : 'oddrow') + '">';
		html += '<td class="prompt">'+aligned.name+'</td>';
		html += '<td class="dottedleft">'+libPlate.name+'</td>';
		html += '<td class="dottedleft">'+pfReads+'</td>';
		html += '<td>'+ptReads+' ('+Math.round(100*ptReads/pfReads)+'%)</td>';
		html += '<td>'+maskedReads+'</td>';
		html += '<td>'+alignedReads+' ('+Math.round(100*alignedReads/pfReads)+'%)</td>';

		html += '<td class="dottedleft">';
		html += '<span class="link item-link" data-item-type="JOB" data-item-id="'+job.id+'" title="'+Strings.encodeTags(job.statusMessage)+'">'+job.status+'</span>';
		html += '</td>';
		if (aligned.DataFilesFolder && job.server)
		{
			html += '<td class="dottedleft">';
			html += '<span class="link file-link" data-server="'+Strings.encodeTags(job.server)+'" data-folder="'+Strings.encodeTags(aligned.DataFilesFolder)+'" data-item-id="'+aligned.id+'" title="View generated files"><img src="../images/remote_folder.png"></span>';
			html += '</td>';
		}
		else
		{
			html += '<td class="dottedleft">-</td>';
		}
		// Do not allow flagging external or stratagene
		var cufflinksChecked = alignedReads > 0 ? 'checked' : '';
		var realignChecked = job.status == 'ERROR' ? 'checked' : '';
		if (lib.stratagene || lib.external)
		{
			html += '<td>-</td>';
			cufflinksChecked = '';
		}
		else
		{
			html += '<td><input type="checkbox" name="flag.'+aligned.id+'"></td>';
		}
		
		html += '<td><input type="checkbox" name="realign.'+aligned.id+'" '+realignChecked+'></td>';
		html += '<td><input type="checkbox" name="cufflinks.'+aligned.id+'" '+cufflinksChecked+'></td>';
		html += '<td class="dottedleft"><input type="text" name="comment.'+aligned.id+'" style="width: 20em;"></td>';
		html += '</tr>';

	}
	html += '</tbody>';
	html += '</table>';
	setInnerHTML('alignedSequences', html);
	
	// Add click handler to items
	var clickableItems = document.getElementsByClassName('item-link');
	for (var i = 0; i < clickableItems.length; i++)
	{
		Events.addEventHandler(clickableItems[i], 'click', Items.itemOnClick);
	}
	
	// Add click handler to file links
	var clickableItems = document.getElementsByClassName('file-link');
	for (var i = 0; i < clickableItems.length; i++)
	{
		Events.addEventHandler(clickableItems[i], 'click', fileLinkOnClick);
	}

}


function goRegister()
{
	if (!step1IsValid()) return;

	var frm = document.forms['reggie'];
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	
	Main.hide('goregister');
	Main.hide('gocancel');
	Main.hide('gonext.message');
	
	var submitInfo = {};
	
	var all = [];
	submitInfo.alignedSequences = all;
	for (var alignedNo = 0; alignedNo < alignedSequences.length; alignedNo++)
	{
		var aligned = alignedSequences[alignedNo];
		var tmp = {};
		tmp.id = aligned.id;
		
		tmp.flag = frm['flag.'+aligned.id] && frm['flag.'+aligned.id].checked;
		tmp.realign = frm['realign.'+aligned.id].checked;
		tmp.cufflinks = frm['cufflinks.'+aligned.id].checked;
		tmp.comment = frm['comment.'+aligned.id].value;
		
		all[all.length] = tmp;
	}
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	
	var url = '../MaskAlign.servlet?ID=<%=ID%>&cmd=RegisterMaskingAndAlignment';
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Performing registration...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	Main.show('gorestart');	
}

function fileLinkOnClick(event)
{
	var folder = Data.get(event.currentTarget, 'folder');
	var server = Data.get(event.currentTarget, 'server');
	var itemId = Data.get(event.currentTarget, 'item-id');
	server = server.replace(/\s*\[.*\]/, '');
	var url = 'view_remote_files.jsp?ID=' + App.getSessionId();
	url += '&clusterId='+server;
	url += '&path='+encodeURIComponent(folder);
	url += '&itemType=DERIVEDBIOASSAY&itemId='+itemId;
	Dialogs.openPopup(url, 'ViewProjectFiles', 750, 500);
}


</script>
<style>
tr.highlight
{
	border-top: 1px dotted #A0A0A0;
}

.dottedleft
{
	border-left: 1px dotted #A0A0A0;
}

.oddrow 
{
	background-color: #F0F0F0;
}

#alignedSequencesTable
{
	width: 100%; 
	border-collapse: collapse;
}

#alignedSequencesTable td
{
	text-align: center;
	min-width: 4.5em;
}

#alignedSequencesTable tbody td
{
	padding-top: 1px;
	padding-bottom: 1px;
}

#alignedSequencesTable .italic
{
	font-style: italic;
}

.file-link
{
	margin-left: 0.5em;
}

</style>
</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Confirm masking and alignment ended" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>
	
	<form name="reggie" onsubmit="return false;">
	
	<div id="step.1.section">
	<table class="stepform" style="width: 95%;">
	<tr>
		<td rowspan="3" class="stepno">1</td>

		<td class="stepfields">
			<div id="alignedSequences"></div>
		</td>
	</tr>
	</table>
	</div>
		
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>" onclick="goRegister()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>