<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

var debug = 1;
var currentStep = 1;
var readStringIsValid = [];
var clusterIsValid = false;

function init()
{
	var frm = document.forms['reggie'];
	var seqRuns = getSequencingRuns();

	// Load confirmed SequencingRun items that has not been demuxed
	if (seqRuns != null && seqRuns.length > 0)
	{
		for (var runNo=0; runNo < seqRuns.length; runNo++)
		{
			var seqRun = seqRuns[runNo];
			var option = getOptionForSeqRun(seqRun);
			frm.seqRuns.options[frm.seqRuns.length] = option;
		}
		sequencingRunOnChange();
	}
	else
	{
		setInputStatus('seqRuns', 'No new sequencing runs available for processing', 'invalid');
	}

	// All is ok
	frm.seqRuns.focus();
}

function getOptionForSeqRun(seqRun)
{
	var flowCell = seqRun.flowCell;
	var name = seqRun.name+': ';
	var numPools = flowCell.pools.length;
	var firstPoolNum = getPoolNum(flowCell.pools[0].name);
	var lastPoolNum = getPoolNum(flowCell.pools[flowCell.pools.length-1].name);

	if (lastPoolNum - firstPoolNum == numPools - 1)
	{
		if (numPools > 1)
		{
			// Display: PoolN -- PoolY
			name += flowCell.pools[0].name + ' — ' + flowCell.pools[flowCell.pools.length-1].name;
		}
		else
		{
			name += flowCell.pools[0].name;
		}
	}
	else
	{
		// Display: PoolN + x more...
		name += flowCell.pools[0].name + ' + ' + (numPools-1) + ' more...';
	}

	// Tooltip is always all pools
	var title = '';
	for (var poolNo=0; poolNo < numPools; poolNo++)
	{
		var pool = flowCell.pools[poolNo];
		if (poolNo > 0) title += ', ';
		title += pool.name;
	}

	var option = new Option(name, seqRun.id);
	option.title = title;
	option.seqRun = seqRun;	
	return option;
}

function getPoolNum(poolName)
{
	var num = poolName.match(/Pool(\d+)/);
	return num ? parseInt(num[1], 10) : null;	
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{
		if (step1IsValid()) gotoStep2();
	}
	setCurrentStep(currentStep);
}

function step1IsValid()
{
	var frm = document.forms['reggie'];
	for (var seqNo = 0; seqNo < frm.seqRuns.length; seqNo++)
	{
		if (frm.seqRuns[seqNo].selected) return true;
	}
	setInputStatus('seqRuns', 'Select at least one sequencing run', 'invalid');
	return false;
}

function step2IsValid()
{
	if (!clusterIsValid) return false;
	
	var frm = document.forms['reggie'];
	for (var seqNo = 0; seqNo < frm.seqRuns.length; seqNo++)
	{
		if (frm.seqRuns[seqNo].selected) 
		{
			if (!readStringIsValid[seqNo]) return false;
		}
	}
	return true;
}


function getSequencingRuns()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading sequencing runs...');
		var url = '../DemuxMerge.servlet?ID=<%=ID%>&cmd=GetConfirmedSequencingRuns';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	return response.sequencingRuns;
}


function formatDate(value)
{
	if (!value) return '';
	if (value.length == 8)
	{
		// YYYYMMDD
		value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2);
	}
	else if (value.length == 13)
	{
		// YYYYMMDD HHMM
		value = value.substr(0, 4) + '-' + value.substr(4, 2) + '-' + value.substr(6, 2) + ' ' + value.substr(9, 2) + ':' + value.substr(11, 2);
	}
	return value;
}


function gotoStep2()
{
	var frm = document.forms['reggie'];
	
	// Disable controls
	frm.seqRuns.disabled = true;

	currentStep = 2;
	Main.show('step.2.section');
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	Main.show('gocancel');
	Main.show('goregister');
	Main.hide('gonext');
	
	// ReadString input fields
	var html = '';
	for (var seqNo = 0; seqNo < frm.seqRuns.length; seqNo++)
	{
		if (frm.seqRuns[seqNo].selected)
		{
			var seqRun = frm.seqRuns[seqNo].seqRun;
			var fc = seqRun.flowCell;
			
			html += '<tr valign="top" style="border-top: 1em solid transparent;">';
			html += '<td class="prompt">'+Main.encodeTags(seqRun.name)+'</td>';
			html += '<td>'+seqRun.SequencingCycles+'</td>';
			html += '<td class="status"></td>';
			html += '<td class="help"></td>';
			html += '</tr>';
			
			html += '<tr valign="top">';
			html += '<td class="subprompt">ReadString</td>';
			html += '<td><input type="text" class="required" name="readString.'+seqNo+'" value="'+seqRun.ReadString+'" style="width: 11em;" onblur="readStringOnBlur('+seqNo+')"></td>';
			html += '<td class="status" id="readString.'+seqNo+'.status"></td>';
			html += '<td class="help"><span id="readString.'+seqNo+'.message"></span></td>';
			html += '</tr>';
			
			html += '<tr>';
			html += '<td class="subprompt">Omit lanes</td>';
			html += '<td>';
			for (var laneNo = 1; laneNo <= fc.numLanes; laneNo++)
			{
				var checked = fc.FailedLanes.indexOf(laneNo) >= 0 ? 'checked' : '';
				html += '<label><input type="checkbox" name="omitLanes.'+seqNo+'" value="'+laneNo+'" ' + checked + '>'+laneNo+'</label> ';
			}
			html += '</td>';
			html += '<td class="status"></td>';
			html += '<td class="help">By default, failed lanes are omitted</td>';
			html += '</tr>';
			
		}
	}
	setInnerHTML('SequencingRun-section', html);
	for (var seqNo = 0; seqNo < frm.seqRuns.length; seqNo++)
	{
		if (frm.seqRuns[seqNo].selected)
		{
			readStringOnBlur(seqNo);
		}
	}
	
	// Load demux protocols
	var demuxProtocols = getProtocols('DEMUX_PROTOCOL');
	for (var i = 0; i < demuxProtocols.length; i++)
	{
		var protocol = demuxProtocols[i];
		frm.demuxProtocol[frm.demuxProtocol.length] = new Option(protocol.name, protocol.id, protocol.isDefault);
		setInputStatus('demuxProtocol', '', 'valid');
	}
	if (frm.demuxProtocol.length == 0)
	{
		frm.demuxProtocol[0] = new Option('- none -', '');
	}
	
	// Load demux software
	var software = getSoftware('DEMUX_SOFTWARE');
	for (var i = 0; i < software.length; i++)
	{
		var sw = software[i];
		frm.demuxSoftware[frm.demuxSoftware.length] = new Option(sw.name, sw.id, sw.isDefault);
		setInputStatus('demuxSoftware', '', 'valid');
	}
	if (frm.demuxSoftware.length == 0)
	{
		frm.demuxSoftware[0] = new Option('- none -', '');
	}
	
	// Load clusters
	var clusters = getClusters();
	for (var i = 0; i < clusters.length; i++)
	{
		var cl = clusters[i];
		var option = new Option(cl.name, cl.id);
		option.cluster = cl;
		frm.clusters[frm.clusters.length] = option;
		setInputStatus('clusters', '', 'valid');
		clusterIsValid = true;
	}
	if (frm.clusters.length == 0)
	{
		setInputStatus('clusters', 'No available Open Grid clusters', 'invalid');
		clusterIsValid = false;
	}
	else
	{
		clusterOnChange();
	}
	// Check debug by default if debug is set or not on a secure server (=production server)
	frm.debug.checked = debug || location.protocol != 'https:';
	
	// Load merge protocols
	var mergeProtocols = getProtocols('MERGE_PROTOCOL');
	for (var i = 0; i < mergeProtocols.length; i++)
	{
		var protocol = mergeProtocols[i];
		frm.mergeProtocol[frm.mergeProtocol.length] = new Option(protocol.name, protocol.id, protocol.isDefault);
		setInputStatus('mergeProtocol', '', 'valid');
	}
	if (frm.mergeProtocol.length == 0)
	{
		frm.mergeProtocol[0] = new Option('- none -', '');
	}
	
	// Load merge software
	var software = getSoftware('MERGE_SOFTWARE');
	for (var i = 0; i < software.length; i++)
	{
		var sw = software[i];
		frm.mergeSoftware[frm.mergeSoftware.length] = new Option(sw.name, sw.id, sw.isDefault);
		setInputStatus('mergeSoftware', '', 'valid');
	}
	if (frm.mergeSoftware.length == 0)
	{
		frm.mergeSoftware[0] = new Option('- none -', '');
	}
}

function clusterOnChange()
{
	var frm = document.forms['reggie'];
	
	var cluster = frm.clusters[frm.clusters.selectedIndex].cluster;
	if (cluster.priorities && cluster.priorities.length > 0)
	{
		frm.priority.length = 0;
		for (var pNo = 0; pNo < cluster.priorities.length; pNo++)
		{
			var p = cluster.priorities[pNo];
			frm.priority[frm.priority.length] = new Option(p.name + ' ('+p.value+')', p.value, p['default']);
		}
		Main.show('job-priority');
	}
	else
	{
		Main.hide('job-priority');
	}
}

function readStringOnBlur(seqNo)
{
	var frm = document.forms['reggie'];

	var readString = frm['readString.'+seqNo].value;
	setInputStatus('readString.'+seqNo, '', '');
	readStringIsValid[seqNo] = false;
	
	if (!readString.match(/^(\d+[TBS])+$/))
	{
		setInputStatus('readString.'+seqNo, 'Invalid read string', 'invalid');
		return;
	}
	setInputStatus('readString.'+seqNo, '', 'valid');
	readStringIsValid[seqNo] = true;
	
}

function getProtocols(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' protocols...');
		var url = '../Protocol.servlet?ID=<%=ID%>&cmd=GetProtocols&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.protocols;
}

function getSoftware(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' hardware...');
		var url = '../Software.servlet?ID=<%=ID%>&cmd=GetSoftware&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.software;
}

function getClusters()
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading Open Grid Scheduler clusters...');
		var url = '../OpenGrid.servlet?ID=<%=ID%>&cmd=GetHostInfo';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.clusters;
}


function goRegister()
{
	if (!step2IsValid()) return;

	var frm = document.forms['reggie'];
	
	frm.demuxSoftware.disabled = true;
	frm.demuxProtocol.disabled = true;
	frm.mergeSoftware.disabled = true;
	frm.mergeProtocol.disabled = true;
	frm.priority.disabled = true;
	frm.debug.disabled = true;
	
	Main.addClass(document.getElementById('step.2.section'), 'disabled');
	
	Main.hide('goregister');
	Main.hide('gocancel');
	Main.hide('gonext.message');
	
	var submitInfo = {};
	
	submitInfo.demuxSoftware = parseInt(frm.demuxSoftware.value);
	submitInfo.demuxProtocol = parseInt(frm.demuxProtocol.value);
	submitInfo.mergeSoftware = parseInt(frm.mergeSoftware.value);
	submitInfo.mergeProtocol = parseInt(frm.mergeProtocol.value);
	submitInfo.cluster = frm.clusters.value;
	if (frm.priority.selectedIndex >= 0)
	{
		submitInfo.priority = parseInt(frm.priority.value);
	}
	submitInfo.debug = frm.debug.checked;
	
	var sequencingRuns = [];
	submitInfo.sequencingRuns = sequencingRuns;
	
	for (var seqNo = 0; seqNo < frm.seqRuns.length; seqNo++)
	{
		if (frm.seqRuns[seqNo].selected) 
		{
			frm['readString.'+seqNo].disabled = true;
			var seqRun = {};
			seqRun.id = frm.seqRuns[seqNo].seqRun.id;
			seqRun.ReadString = frm['readString.'+seqNo].value;
			
			var omitLanes = [];
			var checkboxes = frm['omitLanes.'+seqNo];
			for (var i = 0; i < checkboxes.length; i++)
			{
				if (checkboxes[i].checked) 
				{
					omitLanes[omitLanes.length] = parseInt(checkboxes[i].value);
				}
			}
			seqRun.OmitLanes = omitLanes;
			sequencingRuns[sequencingRuns.length] = seqRun;
		}
	}
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	var url = '../DemuxMerge.servlet?ID=<%=ID%>&cmd=StartDemuxAndMerge';
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Performing registration...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	Main.show('gorestart');	
}


var subtypeSeqRun = null;
function selectSeqRuns()
{
	var frm = document.forms['reggie'];
	if (frm.seqRuns.disabled) return;
	
	if (subtypeSeqRun == null)
	{
		var request = Ajax.getXmlHttpRequest();
		var url = '../Subtype.servlet?ID=<%=ID%>&cmd=GetSubtypeInfo&name=SEQUENCING_RUN';
		request.open("GET", url, false);	
		request.send(null);

		if (debug) Main.debug(request.responseText);
		var response = JSON.parse(request.responseText);	
		if (response.status != 'ok')
		{
			setFatalError(response.message);
			return false;
		}
		subtypeSeqRun = response.subtype;
	}
	
	var url = getRoot() + 'views/derivedbioassays/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectmultiple&callback=setSeqRunCallback';
	url += '&tmpfilter:INT:itemSubtype='+subtypeSeqRun.id;
	Main.openPopup(url, 'SelectSequencingRuns', 1000, 700);
}

function setSeqRunCallback(id, name)
{
	var frm = document.forms['reggie'];
	var seqRunList = frm.seqRuns;
	for (var i = 0; i < seqRunList.length; i++)
	{
		if (seqRunList[i].value == id)
		{
			seqRunList[i].selected = true;
			setInputStatus('seqRuns', '', '');
			return;
		}
	}
	
	// Get more information about the selected sequencing run
	var request = Ajax.getXmlHttpRequest();
	var url = '../DemuxMerge.servlet?ID=<%=ID%>&cmd=GetSequencingRunInfo&id=' + id;		
	request.open("GET", url, false);	
	request.send(null);
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	
	var seqRun = response.sequencingRun;
	var option = getOptionForSeqRun(seqRun);
	option.selected = true;
	seqRunList[seqRunList.length] = option;
	setInputStatus('seqRuns', '', '');
}

</script>
<style>

</style>
</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Start demux and merge" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>

	<form name="reggie" onsubmit="return false;">
	
	<div id="step.1.section">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select sequencing runs</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table style="border-collapse: collapse;">
			<tr valign="top">
				<td class="prompt">Sequencing runs</td>
				<td class="input"><select class="required" style="width:90%;" multiple
						name="seqRuns" id="seqRuns"></select>
						
					<base:buttongroup style="margin-top: 0.5em;">
						<base:button title="Select manually&hellip;" onclick="selectSeqRuns()" id="btnSelectSeqRuns" />
					</base:buttongroup>
				</td>
				<td class="status" id="seqRuns.status"></td>
				<td class="help"><span id="seqRuns.message" class="message" style="display: none;"></span>
					Select the sequencing runs that should be demuxed. Data for libraries that are found
					in multiple places are merged to a single item for that library. 
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<div id="step.2.section" style="display: none;">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">2</td>
		<td class="steptitle" id="step.2.title">Demux and merge information</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table style="border-collapse: collapse;">
			<tr valign="top" style="background-color: #E8E8E8;">
				<td class="prompt">Demux</td>
				<td class="input"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Software</td>
				<td class="input"><select style="width:90%" name="demuxSoftware" id="demuxSoftware" 
					onkeypress="focusOnEnter(event, 'demuxProtocol')"></select></td>
				<td class="status" id="demuxSoftware.status"></td>
				<td class="help"><span id="demuxSoftware.message" class="message" style="display: none;"></span>
					Select the software to use for demuxing.
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Protocol</td>
				<td class="input"><select style="width:90%" name="demuxProtocol" id="demuxProtocol" 
					onkeypress="focusOnEnter(event, 'fc-0.externalId')"></select></td>
				<td class="status" id="demuxProtocol.status"></td>
				<td class="help"><span id="demuxProtocol.message" class="message" style="display: none;"></span>
					Select the protocol used for demuxing.
				</td>
			</tr>
			<tbody id="SequencingRun-section"></tbody>
			<tr valign="top" style="background-color: #E8E8E8;">
				<td class="prompt">Merge</td>
				<td class="input"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Software</td>
				<td class="input"><select style="width:90%" name="mergeSoftware" id="mergeSoftware" 
					onkeypress="focusOnEnter(event, 'mergeProtocol')"></select></td>
				<td class="status" id="mergeSoftware.status"></td>
				<td class="help"><span id="mergeSoftware.message" class="message" style="display: none;"></span>
					Select the software to use for merging the FASTQ files.
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Protocol</td>
				<td class="input"><select style="width:90%" name="mergeProtocol" id="mergeProtocol" 
					onkeypress="focusOnEnter(event, 'clusters')"></select></td>
				<td class="status" id="mergeProtocol.status"></td>
				<td class="help"><span id="mergeProtocol.message" class="message" style="display: none;"></span>
					Select the protocol used for merging.
				</td>
			</tr>
			<tr valign="top" style="background-color: #E8E8E8;">
				<td class="prompt">Open Grid Scheduler</td>
				<td class="input"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Cluster</td>
				<td class="input"><select style="width:90%" name="clusters" id="clusters" class="required"
					onchange="clusterOnChange()"></select></td>
				<td class="status" id="clusters.status"></td>
				<td class="help"><span id="clusters.message" class="message" style="display: none;"></span>
					Select the cluster to use for running the software.
				</td>
			</tr>
			<tr valign="top" id="job-priority" style="display: none;">
				<td class="subprompt">Job priority</td>
				<td class="input"><select style="width:90%" name="priority" id="priority"></select></td>
				<td class="status" id="priority.status"></td>
				<td class="help"><span id="priority.message" class="message" style="display: none;"></span>
					Select the priority of the job.
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Debug</td>
				<td class="input"><input type="checkbox" name="debug"></td>
				<td class="status" id="debug.status"></td>
				<td class="help"><span id="debug.message" class="message" style="display: none;"></span>
					When running in debug mode only part of the sequenced data is used and
					temporary files are not removed from the cluster node.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
		
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>" onclick="goRegister()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>