<%@ page
	pageEncoding="UTF-8"
	session="false"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.clients.web.Base"	
	import="net.sf.basedb.clients.web.util.HTML"	
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(request, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String home = ExtensionsControl.getHomeUrl("net.sf.basedb.reggie");
DbControl dc = null;
try
{
	dc = sc.newDbControl();
	final User user = User.getById(dc, sc.getLoggedInUserId());
%>
<base:page type="default" >
<base:head scripts="ajax.js" styles="path.css">
	<link rel="stylesheet" type="text/css" href="../css/reggie.css">
	<script language="JavaScript" src="../reggie.js" type="text/javascript" charset="UTF-8"></script>

<script language="JavaScript">

var debug = 0;
var currentStep = 1;

var flowCellsAreValid = false;
var commentsIsValid = [];
var dateIsValid = [];
var flowCellIdIsValid = [];

function init()
{
	var frm = document.forms['reggie'];
	var flowCells = getFlowCells();
	
	// Load existing Flow cells not yet registered
	if (flowCells != null && flowCells.length > 0)
	{
		for (var i=0; i < flowCells.length; i++)
		{
			var flowCell = flowCells[i];
			var name = flowCell.name +': ';

			var numPools = flowCell.pools.length;
			var firstPoolNum = getPoolNum(flowCell.pools[0].name);
			var lastPoolNum = getPoolNum(flowCell.pools[flowCell.pools.length-1].name);

			if (lastPoolNum - firstPoolNum == numPools - 1)
			{
				if (numPools > 1)
				{
					// Display: PoolN -- PoolY
					name += flowCell.pools[0].name + ' — ' + flowCell.pools[flowCell.pools.length-1].name;
				}
				else
				{
					name += flowCell.pools[0].name;
				}
			}
			else
			{
				// Display: PoolN + x more...
				name += flowCell.pools[0].name + ' + ' + (numPools-1) + ' more...';
			}
			
			if (flowCell.FlowCellType)
			{
				name += ' [' + flowCell.FlowCellType + ']';
			}

			// Tooltip is always all pools
			var title = '';
			for (var poolNo=0; poolNo < numPools; poolNo++)
			{
				var pool = flowCell.pools[poolNo];
				if (poolNo > 0) title += ', ';
				title += pool.name;
			}
			
			var option = new Option(name, flowCell.id, i < 2);
			option.title = title;
			option.flowCell = flowCell;
			frm.flowcells.options[frm.flowcells.length] = option;
		}
		flowCellsOnChange();
		outcomeOnChange();
	}
	else
	{
		var msg = 'No flow cells available for processing.';
		setFatalError(msg);
		return;
	}

	// All is ok
	frm.flowcells.focus();
}

function getPoolNum(poolName)
{
	var num = poolName.match(/Pool(\d+)/);
	return num ? parseInt(num[1], 10) : null;	
}

function goNextAuto()
{
	goNext(false);
}

function goNext(manual)
{
	setInnerHTML('gonext.message', '');
	if (currentStep == 1)
	{
		if (step1IsValid()) gotoStep2();
	}
}

// Check that 1 or 2 flow cells are selected
function flowCellsOnChange()
{
	var frm = document.forms['reggie'];	
	flowCellsAreValid = false;
	
	var numSelected = 0;
	for (var i = 0; i < frm.flowcells.length; i++)
	{
		if (frm.flowcells[i].selected) numSelected++;
	}
	
	if (numSelected < 1 || numSelected > 2)
	{
		setInputStatus('flowcells', 'Select 1 or 2 flow cells', 'invalid');
		return false;
	}
	
	setInputStatus('flowcells', '', 'valid');
	flowCellsAreValid = true;
}


function step1IsValid()
{
	return flowCellsAreValid;
}

function step2IsValid()
{
	var frm = document.forms['reggie'];
	var failed = frm.outcome[1].checked;
	if (failed && !frm.verifyFailure.checked) return false;
	
	if (!dateIsValid['clusterDate']) return false;
	
	var index = 0;
	for (var i = 0; i < frm.flowcells.length; i++)
	{
		if (frm.flowcells[i].selected)
		{
			var fc = frm.flowcells[i].flowCell;
			if (flowCellIdIsValid['fc-'+index+'.externalId'] != true) return false;
			if (commentsIsValid['fc-'+index+'.comments'] != true) return false;
			index++;
		}
	}
	
	return true;	
}

function verifyFailureOnClick()
{
	var frm = document.forms['reggie'];
	var checked = frm.verifyFailure.checked;
	Main.addOrRemoveClass(document.getElementById('goregister'), 'disabled', !checked);
}


function getFlowCells()
{
	var frm = document.forms['reggie'];	
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading flow cells lists...');
		var url = '../FlowCell.servlet?ID=<%=ID%>&cmd=GetUnprocessedFlowCells';		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.flowCells;
}

function gotoStep2()
{
	var frm = document.forms['reggie'];
	
	// Disable controls
	frm.flowcells.disabled = true;
	frm.outcome[0].disabled = true;
	frm.outcome[1].disabled = true;
	
	var failed = frm.outcome[1].checked;

	currentStep = 2;
	Main.show('step.2.section');
	Main.addClass(document.getElementById('step.1.section'), 'disabled');
	Main.show('gocancel');
	
	Main.hide('gonext');
	Main.show('goregister');
	
	if (failed)
	{
		setInnerHTML('gonext.message', '<input type="checkbox" name="verifyFailure" onclick="verifyFailureOnClick()"> Check to verify registration of failure');
		Main.addClass(document.getElementById('goregister'), 'disabled');
	}

	// Load clustering protocols
	var clusterProtocols = getProtocols('CLUSTER_PROTOCOL');
	for (var i = 0; i < clusterProtocols.length; i++)
	{
		var protocol = clusterProtocols[i];
		frm.clusterProtocol[frm.clusterProtocol.length] = new Option(protocol.name, protocol.id, protocol.isDefault);
		setInputStatus('clusterProtocol', '', 'valid');
	}
	if (frm.clusterProtocol.length == 0)
	{
		frm.clusterProtocol[0] = new Option('- none -', '');
	}
	
	var index = 0;
	var flowCellType = null;
	for (var i = 0; i < frm.flowcells.length && index < 2; i++)
	{
		if (frm.flowcells[i].selected)
		{
			var fc = frm.flowcells[i].flowCell;
			if (flowCellType == null) flowCellType = fc.FlowCellType;
			var prefix = 'fc-'+index;
			setInnerHTML(prefix+'.name.c', fc.name);
			frm[prefix+'.comments'].value = fc.comments;
			commentsOnChange(prefix+'.comments');
			frm[prefix+'.externalId'].value = fc.externalId;
			flowCellIdOnBlur(prefix+'.externalId');
			index++;
		}
	}

	if (index == 1)
	{
		// Only one flow cell selected
		Main.addClass(document.getElementById('step.2.section'), 'hide-fc-1');
	}
	
	// Load cBot machines
	var cbots = getHardware(flowCellType == 'NextSeq' ? 'SEQUENCER' : 'CLUSTER_GENERATOR');
	for (var i = 0; i < cbots.length; i++)
	{
		var cbot = cbots[i];
		frm.cBot[frm.cBot.length] = new Option(cbot.name, cbot.id, cbot.isDefault);
		setInputStatus('cBot', '', 'valid');
	}
	if (cbots.length == 0)
	{
		frm.cBot[0] = new Option('- none -', '');
	}

	
	frm.clusterDate.focus();
}

function disableStep2()
{
	var frm = document.forms['reggie'];
	// Disable controls
	frm.clusterProtocol.disabled = true;
	frm.clusterDate.disabled = true;
	frm.clusterOperator.disabled = true;
	frm.cBot.disabled = true;
	frm['fc-0.externalId'].disabled = true;
	frm['fc-0.comments'].disabled = true;
	frm['fc-1.externalId'].disabled = true;
	frm['fc-1.comments'].disabled = true;
	Main.addClass(document.getElementById('step.2.section'), 'disabled');
}


function getProtocols(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' protocols...');
		var url = '../Protocol.servlet?ID=<%=ID%>&cmd=GetProtocols&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.protocols;
}

function getHardware(subtype)
{
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Loading ' + subtype + ' hardware...');
		var url = '../Hardware.servlet?ID=<%=ID%>&cmd=GetHardware&subtype='+subtype;		
		request.open("GET", url, false);	
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}

	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);	
	if (response.status != 'ok')
	{
		setFatalError(response.message);
		return false;
	}
	return response.hardware;
}


function outcomeOnChange()
{
	var frm = document.forms['reggie'];
	var failed = document.getElementById('outcomeFailed').checked;
	Main.addOrRemoveClass(frm['fc-0.comments'], 'required', failed);
	Main.addOrRemoveClass(frm['fc-1.comments'], 'required', failed);
}

function dateOnChange(dateField)
{
	var frm = document.forms['reggie'];

	setInputStatus(dateField, '', '');
	dateIsValid[dateField] = true;
	var date = frm[dateField].value;

	if (date == '')
	{
		var required = frm[dateField].className.indexOf('required') != -1;
		setInputStatus(dateField, 'Missing date', required ? 'invalid' : 'warning');
		if (required) dateIsValid[dateField] = false;
		return;
	}

	// Auto-fill the date if it's only given with 4(MMdd) or 6(yyMMdd) digits.		
	date = autoFillDate(date);
	frm[dateField].value = date;
	if (!Dates.isDate(date, 'yyyyMMdd'))
	{
		setInputStatus(dateField, 'Not a valid date', 'invalid');
		dateIsValid[dateField] = false;
		return;
	}
	
	setInputStatus(dateField, '', 'valid');
}

function setDate(frmName, dateField, date)
{
	var frm = document.forms['reggie'];
	frm[dateField].value = date;
	dateOnChange(dateField);
	frm[dateField].focus();
}

// Cluster comments are required when 'Failure' has been selected
function commentsOnChange(commentField)
{
	var frm = document.forms['reggie'];
	commentsIsValid[commentField] = false;
	setInputStatus(commentField, '', '');
	
	var comments = frm[commentField].value;
	if (comments == '')
	{
		var required = frm[commentField].className.indexOf('required') != -1;
		if (required)
		{
			setInputStatus(commentField, 'Missing', 'invalid');
			return;
		}
	}

	setInputStatus(commentField, '', 'valid');
	commentsIsValid[commentField] = true;
}

function flowCellIdOnBlur(idField)
{
	var frm = document.forms['reggie'];
	
	setInputStatus(idField, '', '');
	flowCellIdIsValid[idField] = false;
	
	var id = frm[idField].value;
	if (id == '')
	{
		setInputStatus(idField, 'ID is a required value', 'invalid');
		return;
	}
	
	if (idField == 'fc-1.externalId')
	{
		if (id == frm['fc-0.externalId'].value)
		{
			setInputStatus(idField, 'ID must be different', 'invalid');
			return;
		}
	}
	else
	{
		flowCellIdOnBlur('fc-1.externalId');
	}
	
	// Check if ID already exists in DB
	try
	{
		var existing = getFlowCellInfoByBarcode(id);
		if (existing != null)
		{
			setInputStatus(idField, 'Flow cell with ID='+id+' already exists: ' + existing.name, 'invalid');
			return;
		}
	}
	catch (error)
	{
		setInputStatus(idField, error, 'invalid');
		return;
	}
	
	setInputStatus(idField, '', 'valid');
	flowCellIdIsValid[idField] = true;
}

function getFlowCellInfoByBarcode(barcode)
{
	var url = '../FlowCell.servlet?ID=<%=ID%>&cmd=GetFlowCellByBarcode';
	url += '&barcode='+encodeURIComponent(barcode);
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Checking flow cell id...');
		request.open("GET", url, false);
		request.send(null);
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);

	if (response.status != 'ok')
	{
		throw response.message;
	}

	return response.flowCell;
}


function goRegister()
{
	var failed = document.getElementById('outcomeFailed').checked;
	var frm = document.forms['reggie'];

	if (!step2IsValid()) return;
	disableStep2();
	
	Main.hide('goregister');
	Main.hide('gocancel');
	Main.hide('gonext.message');
	
	var submitInfo = {};
	submitInfo.failed = failed;
	
	submitInfo.flowCells = [];
	var index = 0;
	for (var i = 0; i < frm.flowcells.length; i++)
	{
		if (frm.flowcells[i].selected) 
		{
			var fc = frm.flowcells[i].flowCell;
			fc.externalId = frm['fc-'+index+'.externalId'].value;
			fc.clusterDate = frm.clusterDate.value;
			fc.clusterOperator = frm.clusterOperator.value;
			fc.cBot = parseInt(frm.cBot.value, 10);
			fc.clusterProtocol = parseInt(frm.clusterProtocol.value, 10);
			fc.comments = frm['fc-'+index+'.comments'].value;
			submitInfo.flowCells[submitInfo.flowCells.length] = fc;
			index++;
		}
	}
	
	if (debug) Main.debug(JSON.stringify(submitInfo));
	var url = '../FlowCell.servlet?ID=<%=ID%>&cmd=RegisterFlowCells';
	
	var request = Ajax.getXmlHttpRequest();
	try
	{
		showLoadingAnimation('Performing registration...');
		request.open("POST", url, false);
		request.send(JSON.stringify(submitInfo));
	}
	finally
	{
		hideLoadingAnimation();
	}
	
	if (debug) Main.debug(request.responseText);
	var response = JSON.parse(request.responseText);
	
	if (response.messages && response.messages.length > 0)
	{
		var msg = '<ul>';
		for (var i = 0; i < response.messages.length; i++)
		{
			var msgLine = response.messages[i];
			if (msgLine.indexOf('[Warning]') >= 0)
			{
				msg += '<li class="warning">' + msgLine.replace('[Warning]', '');
			}
			else
			{
				msg += '<li>' + msgLine;
			}
		}
		msg += '</ul>';
		setInnerHTML('messages', msg);
		Main.show('messages');
	}
	
	if (response.status != 'ok')
	{
		Main.addClass(document.getElementById('messages'), 'failure');
		setFatalError(response.message);
		return false;
	}

	Main.show('gorestart');	
}

</script>
<style>
#step\.2\.section.hide-fc-1  .fc-1
{
	display: none;
}

#step\.3\.section.hide-fc-1  .fc-1
{
	display: none;
}

</style>
</base:head>
<base:body onload="init()">

	<p:path><p:pathelement 
		title="Reggie" href="<%="../index.jsp?ID="+ID%>" 
		/><p:pathelement title="Register clustering" 
		/></p:path>

	<div class="content">
	<%
	if (sc.getActiveProjectId() == 0)
	{
		%>
		<div class="messagecontainer note" style="width: 950px; margin-left: 20px; margin-bottom: 20px; margin-right: 0px; font-weight: bold; color: #cc0000;">
			No project has been selected. You may proceed with the registration but 
			created items will not be shared.
		</div>
		<%
	}
	%>


	<form name="reggie" onsubmit="return false;">
	<div id="step.1.section">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">1</td>
		<td class="steptitle">Select flow cells</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table>
			<tr valign="top">
				<td class="prompt">Flow cells</td>
				<td class="input"><select class="required" style="width:90%;" 
						name="flowcells" id="flowcells" multiple size="4" onchange="flowCellsOnChange()"></select>
				</td>
				<td class="status" id="flowcells.status"></td>
				<td class="help"><span id="flowcells.message" class="message" style="display: none;"></span>
					Select 1 or 2 existing flow cells. The list contain all flow cells that
					has not yet been clustered or sequenced (determined by the absence of a 'creation' date).
				</td>
			</tr>
			<tr valign="top">
				<td colspan="2">
					<div class="messagecontainer note">
						<b>Note!</b>
						Register each flow cell separately if the outcome, cluster date, operator, etc. is different.
					</div>
						
				</td>
				<td class="status" ></td>
				<td class="help">
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Outcome</td>
				<td class="input">
					<input type="radio" name="outcome" id="outcomeSuccess" 
						onchange="outcomeOnChange()" checked><label for="outcomeSuccess">Success</label> - continue with sequencing<br>
					<input type="radio" name="outcome" id="outcomeFailed" 
						onchange="outcomeOnChange()"><label for="outcomeFailed">Failure</label> - no sequencing
				</td>
				<td class="status"></td>
				<td class="help">
					Select the <b>Success</b> option if the flow cell is ready for sequencing. 
					Select the <b>Failure</b> option if it was not poosible to start sequencing
					the flow cells.
				</td>
			</tr>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	<div id="step.2.section" style="display: none;">
	<table class="stepform">
	<tr>
		<td rowspan="3" class="stepno">2</td>
		<td class="steptitle">Clustering information</td>
	</tr>
	<tr>
		<td class="stepfields">
			<table style="border-collapse: collapse;">
			<tr valign="top">
				<td class="prompt">Start date</td>
				<td class="input">
					<input type="text" class="required" name="clusterDate" value="" size="12" maxlength="10"
						onblur="dateOnChange(this.name)" onkeypress="focusOnEnter(event, 'clusterOperator')">
						<base:icon 
							onclick="Dates.selectDate('Cluster date', 'reggie', 'clusterDate', 'setDate', 'yyyyMMdd')"
							image="calendar.png" 
							tooltip="Select a date from a calendar" 
							tabindex="-1"
						/>
				</td>
				<td class="status" id="clusterDate.status"></td>
				<td class="help">
					<span id="clusterDate.message" class="message" style="display: none;"></span>Date the clustering was started (YYYYMMDD or MMDD)
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Operator</td>
				<td class="input">
					<input type="text" name="clusterOperator" value="<%=HTML.encodeTags(user.getName()) %>" 
						style="width: 90%;" maxlength="255" onkeypress="focusOnEnter(event, 'cBot')">
				</td>
				<td class="status" id="clusterOperator.status"></td>
				<td class="help">
					<span id="clusterOperator.message" class="message" style="display: none;"></span>
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Cluster generator</td>
				<td class="input"><select style="width:90%" name="cBot"  
					onkeypress="focusOnEnter(event, 'clusterProtocol')"></select></td>
				<td class="status" id="cBot.status"></td>
				<td class="help"><span id="cBot.message" class="message" style="display: none;"></span>
					Select the machine which was used to generate clusters.
				</td>
			</tr>
			<tr valign="top">
				<td class="prompt">Protocol</td>
				<td class="input"><select style="width:90%" name="clusterProtocol" id="clusterProtocol" 
					onkeypress="focusOnEnter(event, 'fc-0.externalId')"></select></td>
				<td class="status" id="clusterProtocol.status"></td>
				<td class="help"><span id="clusterProtocol.message" class="message" style="display: none;"></span>
					Select the protocol which was used in the clustering.
				</td>
			</tr>

			<tbody class="fc-0">
			<tr valign="top" style="background-color: #E8E8E8;">
				<td class="prompt" id="fc-0.name.c">Flow cell A</td>
				<td class="input"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">ID</td>
				<td class="input"><input type="text" class="required" name="fc-0.externalId" onblur="flowCellIdOnBlur(this.name)" onkeypress="focusOnEnter(event, 'fc-0.comments')"></td>
				<td class="status" id="fc-0.externalId.status"></td>
				<td class="help"><span id="fc-0.externalId.message" class="message"></span>
					The barcode of the flow cell.
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Comments</td>
				<td class="input"><textarea rows="4" cols="50" style="width: 90%;" name="fc-0.comments" onblur="commentsOnChange(this.name)"></textarea></td>
				<td class="status" id="fc-0.comments.status"></td>
				<td class="help"><span id="fc-0.comments.message" class="message" style="display: none;"></span>
					Comments about the clustering.
				</td>
			</tr>
			</tbody>
			<tbody class="fc-1">
			<tr valign="top" style="background-color: #E8E8E8;">
				<td class="prompt" id="fc-1.name.c">Flow cell B</td>
				<td class="input"></td>
				<td class="status"></td>
				<td class="help"></td>
			</tr>
			<tr valign="top">
				<td class="subprompt">ID</td>
				<td class="input"><input type="text" class="required" name="fc-1.externalId" onblur="flowCellIdOnBlur(this.name)" onkeypress="focusOnEnter(event, 'fc-1.comments')"></td>
				<td class="status" id="fc-1.externalId.status"></td>
				<td class="help"><span id="fc-1.externalId.message" class="message"></span>
					The barcode of the flow cell.
				</td>
			</tr>
			<tr valign="top">
				<td class="subprompt">Comments</td>
				<td class="input"><textarea rows="4" cols="50" style="width: 90%;" name="fc-1.comments" onblur="commentsOnChange(this.name)"></textarea></td>
				<td class="status" id="fc-1.comments.status"></td>
				<td class="help"><span id="fc-1.comments.message" class="message" style="display: none;"></span>
					Comments about the clustering.
				</td>
			</tr>
			</tbody>
			</table>
		</td>
	</tr>
	</table>
	</div>
	
	
	<div class="loading" id="loading" style="display: none;"><table><tr><td><img src="../images/loading.gif"></td><td id="loading.msg">Please wait...</td></tr></table></div>
	
	<div class="messagecontainer error" id="errorMessage" style="display: none; width: 950px; margin-left: 20px; margin-bottom: 0px;"></div>
	
	<div id="messages" class="success" style="display: none; width: 950px; margin-left: 20px; margin-top: 20px;"></div>
	
	<table style="margin-left: 20px; margin-top: 10px;" class="navigation">
		<tr>
			<td><base:button id="gocancel" title="Cancel" onclick="goRestart(false)" style="display: none;"/></td>
			<td><base:button id="gonext" title="Next" image="<%=home+"/images/gonext.png"%>" onclick="goNext(true)"/></td>
			<td><base:button id="goregister" title="Register" image="<%=home+"/images/import.png"%>" onclick="goRegister()" style="display: none;"/></td>
			<td><base:button id="gorestart" title="Restart" image="<%=home+"/images/goback.png"%>" onclick="goRestart(true)" style="display: none;"/></td>
			<td id="gonext.message" class="message"></td>
		</tr>
	</table>
	
	</form>
	</div>
	
</base:body>
</base:page>
<%
}
finally
{
	if (dc != null) dc.close();
}
%>